Subject: Re: bug#12095: Protecting pointer on bytevector with guardian does not protect memory

From: Daniel Hartwig <[email-masked]>
Date: Mon, 8 Oct 2012 07:49:18 +0800

On 8 October 2012 04:38, Ludovic Courtès <[email-masked]> wrote:
>>> This is expected to fail: ‘bytevector->pointer’ creates a weak reference
>>> from the returned pointer object to the given bytevector.  So when the
>>> pointer object is reclaimed, the bytevector can be reclaimed too, hence
>>> the problem you’re observing.  (And no, guardians don’t protect objects
>>> from garbage collection.)
>>
>> If I understand correctly, there is never any non-weak reference to
>> the bv above and so it can be collected at any time.
>
> There’s a weak reference from the pointer object to the bytevector.
>
> Once that pointer object has been collected (as in the example above),
> the bytevector can be collected anytime.

Right.  But then the pointer is being collected even though it remains
inside the guardian, in the example it is never extracted from there.

I'm not sure I follow. :-/